﻿namespace PluginOpenStrongBox
{
    using Styx;
    using Styx.Common;
    using Styx.Common.Helpers;
	using Styx.CommonBot;
    using Styx.CommonBot.Frames;
    using Styx.CommonBot.Inventory;
    using Styx.CommonBot.Profiles;
    using Styx.Helpers;
    using Styx.Pathing;
    using Styx.Plugins;
    using Styx.WoWInternals;
	using Styx.WoWInternals.Misc;
	using Styx.WoWInternals.World;
    using Styx.WoWInternals.WoWObjects;

    using System;
    using System.Collections.Generic;
	using System.ComponentModel;
	using System.Data;
    using System.Diagnostics;
    using System.Drawing;
    using System.IO;
    using System.Linq;
	using System.Reflection;
    using System.Runtime.InteropServices;
    using System.Text;
    using System.Threading;
    using System.Windows.Forms;
    using System.Windows.Media;
    using System.Xml.Linq;

    public class OpenStrongBox : HBPlugin
    {
        public override string Name { get { return "OpenStrongBox"; } }
        public override string Author { get { return "ArmyDr"; } }
        public override Version Version { get { return new Version(1,0,1); } }
		public bool InventoryCheck = false;
		private bool _init = false;
		
        public override void OnEnable()
        {
            Lua.DoString("SetCVar('AutoLootDefault','1')");
            Logging.Write(LogLevel.Normal, Colors.DarkRed, "OpenStrongBox is ready to open...");
            Lua.Events.AttachEvent("UPDATE_BATTLEFIELD_STATUS", OpenBoxes);
            _init = true;
            base.OnEnable();
        }

		public override void OnDisable()
        {
            Logging.Write(System.Windows.Media.Colors.Pink, "OpenStrongBox Disabled");
			Lua.Events.DetachEvent("UPDATE_BATTLEFIELD_STATUS", OpenBoxes);
            base.OnDisable();
        }
        		
        public override void Pulse()
        {
  			if (_init){
				if (StyxWoW.Me.IsActuallyInCombat
					|| StyxWoW.Me.Mounted
					|| StyxWoW.Me.IsDead
					|| StyxWoW.Me.IsGhost
					) {
					return;
				}

				if (InventoryCheck) { // Zone Changed It Should Open Box
					foreach (WoWItem item in ObjectManager.GetObjectsOfType<WoWItem>()) { // iterate over every item
						if (item != null && item.BagSlot != -1 && StyxWoW.Me.FreeNormalBagSlots >= 2) { // check if item exists and is in bag and we have space
							if (_itemRequiresSleep.Contains(item.Entry)) { 
								if (item.StackCount >= 1) {
									this.useItem(item);
								}
							} 
						}
					}
					InventoryCheck = false;
                    _init = false;
					StyxWoW.SleepForLagDuration();
				}
            }
        }

		public void OpenBoxes (object sender, LuaEventArgs args)
		{
            InventoryCheck = true;
            _init = true;
			Logging.Write(System.Windows.Media.Colors.Pink, "Checking For StrongBoxes...");
		}
		
        public void useItem(WoWItem item)
        {
            Logging.Write(LogLevel.Normal, Colors.DarkRed, "[{0} {1}]: Using {2} we have {3}", this.Name, this.Version, item.Name, item.StackCount);
			
            if (_itemRequiresSleep.Contains(item.Entry)) {
                // some (soulbound) items require an additional sleep to prevent a loot bug
                StyxWoW.SleepForLagDuration();
            }
            Lua.DoString("UseItemByName(\"" + item.Name + "\")");
            StyxWoW.SleepForLagDuration();
        }

        public HashSet<uint> _itemRequiresSleep = new HashSet<uint>() {
		    111598, //STRONGBOX IDs
			111599,
			111600,
			119330,
			120354,
			120355,
			120356,
			120353,
        };
    }
}